﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Microsoft.Surface;
using Microsoft.Surface.Presentation;
using Microsoft.Surface.Presentation.Controls;
using HTPAPI;

namespace HTPBehaviorLab
{
    /// <summary>
    /// Interaction logic for BehaviorBox.xaml
    /// </summary>
    public partial class BehaviorBox : UserControl
    {
        private HapticBehavior b;

        public HapticBehavior Behavior
        {
            get
            {
                return this.b;
            }
            set
            {
                this.b = value;
                if (b is OscillationBehavior)
                {
                    this.title.Text = "Oscillation Behavior";
                }
                else if (b is SoftnessBehavior)
                {
                    this.title.Text = "Softness Behavior";
                }
                else if (b is IntensityBehavior)
                {
                    this.title.Text = "Intensity Behavior";
                }
                else if (b is BreakyBehavior)
                {
                    this.title.Text = "Breakiness Behavior";
                }
            }
        }


        public BehaviorBox()
        {
            InitializeComponent();
        }

        private void SurfaceSlider_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            if (b is OscillationBehavior)
            {
                (this.b as OscillationBehavior).Frequency = e.NewValue;
            }
            else if (b is SoftnessBehavior)
            {
                (this.b as SoftnessBehavior).Softness = e.NewValue;
            }
            else if (b is IntensityBehavior)
            {
                (this.b as IntensityBehavior).Intensity = e.NewValue;
            }
            else if (b is BreakyBehavior)
            {
                (this.b as BreakyBehavior).BreakySteps = e.NewValue;
            }
            this.paramVal.Text = e.NewValue.ToString();
        }

        private void SurfaceSlider_ValueChanged_1(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            b.Ratio = e.NewValue;
            this.ratioVal.Text = e.NewValue.ToString();
        }
    }
}
